<?php
/**
 * The main template file
 */

	get_header();


	if( is_tax('portfolio_category') || is_tax('portfolio_tag') && class_exists('gdlr_core_pb_element_portfolio') ){
		$post_type = 'portfolio';

		$sidebar_type = chariti_get_option('general', 'archive-portfolio-sidebar', 'none');
		$sidebar_left = chariti_get_option('general', 'archive-portfolio-sidebar-left');
		$sidebar_right = chariti_get_option('general', 'archive-portfolio-sidebar-right');		
	}else{
		$post_type = 'post';

		$sidebar_type = chariti_get_option('general', 'archive-blog-sidebar', 'none');
		$sidebar_left = chariti_get_option('general', 'archive-blog-sidebar-left');
		$sidebar_right = chariti_get_option('general', 'archive-blog-sidebar-right');
	}

	if( $sidebar_type == 'left' && !is_active_sidebar($sidebar_left) ){
		$sidebar_type = 'none';
	}
	if( $sidebar_type == 'right' && !is_active_sidebar($sidebar_right) ){
		$sidebar_type = 'none';
	}

	echo '<div class="chariti-content-container chariti-container">';
	echo '<div class="' . esc_attr(chariti_get_sidebar_wrap_class($sidebar_type)) . '" >';

	// sidebar content
	echo '<div class="' . esc_attr(chariti_get_sidebar_class(array('sidebar-type'=>$sidebar_type, 'section'=>'center'))) . '" >';
	
	if( $post_type == 'portfolio' && class_exists('gdlr_core_pb_element_portfolio') ){

		get_template_part('content/archive', 'portfolio');

	}else if( class_exists('gdlr_core_pb_element_blog') ){

		get_template_part('content/archive', 'blog');
		
	}else{

		get_template_part('content/archive', 'default');
		
	}

	echo '</div>'; // chariti-get-sidebar-class

	// sidebar left
	if( $sidebar_type == 'left' || $sidebar_type == 'both' ){
		echo chariti_get_sidebar($sidebar_type, 'left', $sidebar_left);
	}

	// sidebar right
	if( $sidebar_type == 'right' || $sidebar_type == 'both' ){
		echo chariti_get_sidebar($sidebar_type, 'right', $sidebar_right);
	}

	echo '</div>'; // chariti-get-sidebar-wrap-class
 	echo '</div>'; // chariti-content-container


	get_footer(); 
?>